#include <stdio.h>
#include <mt_gem.h>
#include "bug.rsh"

// IMPORTANT:
// ==========
// uncomment the define statement,
// to trigger the xaaes-toolbar-key-event-eater-bug:

//#define WITH_TOOLBAR


#define MY_RESOURCE_FILE "bug.rsc"
#define MY_TIMERVAL 1000

short gl_app;
short gl_appwin;
short gl_quit=0;
short gl_vdi_out[60];
short gl_vdi_vh;
OBJECT *gl_deskmenu = NULL;
OBJECT *gl_toolbar = NULL;


static void handle_redraw(void)
{
    GRECT work, todo, cur, tb;
    short pxy[8];

    wind_get_grect(gl_appwin, WF_WORKXYWH, &work);

    if (wind_get_grect(gl_appwin, WF_FIRSTXYWH, &cur) != 0) {

        pxy[0] = work.g_x;
        pxy[1] = work.g_y;
        pxy[2] = pxy[0]+work.g_w-1;
        pxy[3] = pxy[1]+work.g_h-1;
        vs_clip(gl_vdi_vh, 1, pxy);
        vst_color(gl_vdi_vh, 1);
        vsf_color(gl_vdi_vh, 0);
        vsf_perimeter(gl_vdi_vh, 0);
        vsf_interior(gl_vdi_vh, FIS_SOLID);

        while (cur.g_w && cur.g_h ) {
            todo = cur;
            if (rc_intersect(&work, &todo)) {
                pxy[0] = todo.g_x;
                pxy[1] = todo.g_y;
                pxy[2] = pxy[0]+todo.g_w-1;
                pxy[3] = pxy[1]+todo.g_h-1;
                v_bar(gl_vdi_vh, pxy);
                v_gtext(gl_vdi_vh, work.g_x + 20, work.g_y + 20, "Please press a key...!");
            }
            wind_get_grect(gl_appwin, WF_NEXTXYWH, &cur);
        }
        vs_clip(gl_vdi_vh, 0, pxy);
    }
}

static void handle_menu(short msg[8])
{
    if(msg[4]==DESKMENU_EXIT) {
        gl_quit = 1;
    }
    menu_tnormal(gl_deskmenu, msg[3], 1);
    menu_tnormal(gl_deskmenu, msg[4], 1);
}

static void mainloop(void)
{
    EVMULT_IN em_in = {
        .emi_flags = MU_MESAG | MU_TIMER | MU_KEYBD,
        .emi_bclicks = 1,
        .emi_bmask = 0x103,
        .emi_bstate = 0,
        .emi_m1leave = 0,
        .emi_m1 = {0,0,0,0},
        .emi_m2leave = 0,
        .emi_m2 = {0,0,0,0},
        .emi_tlow = MY_TIMERVAL,
        .emi_thigh = 0
    };
    EVMULT_OUT em_out;
    short msg[8];
    GRECT g;

    while(gl_quit==0) {
        evnt_multi_fast( &em_in, msg, &em_out);
        if( (em_out.emo_events & MU_MESAG) != 0 ) {
            switch(msg[0]) {

            case WM_CLOSED:
                gl_quit = 1;
                break;

            case MN_SELECTED:
                handle_menu(msg);
                break;

            case WM_REDRAW:
                handle_redraw();
                break;

            case WM_MOVED:
                wind_get(gl_appwin, WF_CURRXYWH, &g.g_x, &g.g_y, &g.g_w, &g.g_h);
                wind_set(gl_appwin, WF_CURRXYWH, msg[4], msg[5], g.g_w, g.g_h);
                break;

            case WM_TOPPED:
                wind_set(gl_appwin, WF_TOP, 1, 0, 0, -1);
                break;

            case WM_TOOLBAR:
                if (msg[4] == TOOLBAR_EXIT) {
                    gl_quit = 1;
                }
                break;

            default:
                break;
            }
        } else if( (em_out.emo_events & MU_KEYBD) != 0 ) {
            form_alert(1, "[1][Keyboard Event][OK]");
        }
    }
}

static void init_vdi(void)
{
    short workin[16], i;

    memset((char*)workin, 0, 32);
    for(i=0; i<10; workin[i++] = 0);
    workin[0] = 1;
    workin[10] = 2;
    gl_vdi_vh = graf_handle( NULL, NULL, NULL, NULL);
    v_opnvwk(workin, (VdiHdl*)&gl_vdi_vh, gl_vdi_out);
}

int main(int arcg, char **argv)
{

    gl_app = appl_init();
    if(!rsrc_load(MY_RESOURCE_FILE)) {
        form_alert(1, "[1][Failed to load Resource!][OK]");
        exit(1);
    }

    init_vdi();

    rsrc_gaddr(R_TREE, DESKMENU, &gl_deskmenu);
    rsrc_gaddr(R_TREE, TOOLBAR, &gl_toolbar);

    menu_bar(gl_deskmenu, 1);

    gl_appwin = wind_create(NAME | CLOSER | MOVER, 0, 0, gl_toolbar[0].ob_width, 320);
#ifdef WITH_TOOLBAR
    wind_set(gl_appwin, WF_TOOLBAR, (int)((long)(gl_toolbar)>>16), (int)(long)(gl_toolbar), 0, 0);
#endif
    wind_open(gl_appwin, 10, 40, gl_toolbar[0].ob_width, 400);

    mainloop();

    wind_delete(gl_appwin);
    rsrc_free();
    appl_exit();

}
